/*
==============================================================================

	RpC p[T

==============================================================================
                                      Copyright(C)1998 Fummy (T.Ohtake)
                                      All rights reserved.
==============================================================================

NXꗗ


* End of class list
==============================================================================
$Header:

$Log: $
==============================================================================
*/

#include "secl.h"
#include <stdio.h>

// VXe֐e[u
struct SystemFunctionTable
{
	const char *name;
	void (Compiler::*func)(Token *);
} sysfunctable[] = {
	{ "SherryWRD", Compiler::_SherryWRD },		// FSherryWRD()͐擪ɂ
	{ "AllocatePage", Compiler::_AllocatePage },
	{ "AllocPage", Compiler::_AllocatePage },
	{ "FreePage", Compiler::_FreePage },
	{ "FreePalatte", Compiler::_FreePalatte },
	{ "AllocatePalette", Compiler::_AllocatePalette },
	{ "AllocPalette", Compiler::_AllocatePalette },
	{ "LoadPicture", Compiler::_LoadPicture },
	{ "DrawPicture", Compiler::_DrawPicture },
	{ "DrawPictureTransparent", Compiler::_DrawPictureTransparent },
	{ "DisplayPage", Compiler::_DisplayPage },
	{ "DPage", Compiler::_DisplayPage },
	{ "ActivePage", Compiler::_ActivePage },
	{ "APage", Compiler::_ActivePage },
	{ "MaskPattern", Compiler::_MaskPattern },
	{ "Mask", Compiler::_MaskPattern },
	{ "Line", Compiler::_Line },
	{ "BoxFill", Compiler::_BoxFill },
	{ "Box", Compiler::_Box },
	{ "Fade", Compiler::_Fade },
	{ "PaletteMix", Compiler::_PaletteMix },
	{ "PMix", Compiler::_PaletteMix },
	{ "PaletteContrast", Compiler::_PaletteContrast },
	{ "MoveEffect", Compiler::_MoveEffect },
	{ "MoveTransparent", Compiler::_MoveTransparent },
	{ "TMove", Compiler::_MoveTransparent },
	{ "Move", Compiler::_Move },
	{ "ChangePalette", Compiler::_ChangePalette },
	{ "PALCHG", Compiler::_ChangePalette },
	{ "SetPaletteAll", Compiler::_SetPaletteAll },
	{ "SetPalette", Compiler::_SetPalette },
	{ "Start", Compiler::_Start },
	{ "SetTime", Compiler::_SetTime },
	{ "Time", Compiler::_SetTime },
	{ "SetDelta", Compiler::_SetDelta },
	{ "Delta", Compiler::_SetDelta },
	{ "Wait", Compiler::_Wait },
	{ "TextWindow", Compiler::_TextWindow },
	{ "TextLocate", Compiler::_TextLocate },
	{ "Locate", Compiler::_TextLocate },
	{ "TextColor", Compiler::_TextColor },
	{ "Color", Compiler::_TextColor },
	{ "TextMask", Compiler::_TextMask },
	{ "TextPage", Compiler::_TextPage },
	{ "TextMode", Compiler::_TextMode },
	{ "TMode", Compiler::_TextMode },
	{ "TextClear", Compiler::_TextClear },
	{ "TCls", Compiler::_TextClear },
	{ "TextPatternOFF", Compiler::_TextPatternOFF },
	{ "TextPattern", Compiler::_TextPattern },
	{ "TextHome", Compiler::_TextHome },
	{ "THome", Compiler::_TextHome },
	{ "DrawText", Compiler::_DrawText },
	{ "DrawLyricsRainbow", Compiler::_DrawLyricsRainbow },
	{ "DrawLyrics", Compiler::_DrawLyrics },
	{ "CopyPalette", Compiler::_CopyPalette },
	{ "End", Compiler::_End },
	{ 0, 0}
};

int Compiler::Execute()
{
	next = infile->GetToken();

	errors = 0;
	swrddone = false;
	ton = 1;

	time = 0;
	oldtime = 0;
	delta = 0;

	tw.x = 0;
	tw.y = 0;
	tw.page = -1;
	tw.color = 7;
	tw.mask = 255;
	tw.bcolor = 0;
	tw.left = 0;
	tw.top = 0;
	tw.right = 639;
	tw.bottom = 479;

	activepage = 0;
	displaypage[0] = 0;
	for(int i = 1; i < MAX_DISPPAGE; i++)
		displaypage[i] = -1;
	mask = 255;
	pat = -1;

	while(next)
	{
		// Ԑݒ
		if (oldtime != time)
		{
			PaintVram();
			output->SetTime(time);
			oldtime = time;
		}

		// fobO
		if (debug)
		{
			const Line &linedata = infile->GetLineData(infile->GetLocate());
			output->Debug(linedata.source, linedata.line);
		}

		try
		{
			Parse(variable);
		}
		catch(Error *err)
		{
			ErrorReport(err);

			if (err->type == Error::error || err->type == Error::fatal)
				errors++;

			Error::ErrType e = err->type;

			delete err;

			if (e == Error::fatal)
			{
				DisplayMessage("vIG[ɂRpC𒆒f܂B");
				break;
			}

			if (errors > 20)
			{
				DisplayMessage("G[̂ŃRpC𒆒f܂B");
				break;
			}
		}
	}

	PaintVram();
	output->End();

	if (errors)
	{
		string s;
		s += "G[ ";
		char b[10];
		sprintf(b, "%d", errors);
		s += b;
		s += " ܂";
		DisplayMessage(s);
	}

	DisplayMessage("RpCI");

	return errors;
}

/*
void Compiler::ParseBlock(IdentifyTable *var)
{
	while(next->type != Close)
	{
		Parse(var);
		if (!next)
		{
			infile->ErrorMessage("}ŕĂ܂");
		}
	}
}
*/

/*
double Compiler::ParseExpression(IdentifyTable *var, Token *op)
{
}
*/

int Compiler::Parse(IdentifyTable *var)
{
	if (!next)
		return false;
	else if (!swrddone && next->type != IdentifyName)
	{
		infile->ErrorMessage("\[Xt@C̐擪ɂ ֐ SherryWRD() Kvł", Error::fatal, next->locate);
	}
	else if (next->type == And)
	{
		// EFCg
		time += delta;

		next = infile->GetToken();	// ǂݎ̂
	}
	else if (next->type == TextStart)
	{
		// eLXgs
		TextLyricsOut(next->str.c_str(), tw);

		next = infile->GetToken();
	}
	else if (next->type == IdentifyName)
	{
		// ʎq (=֐)
		string name = next->str;
		int erp = next->locate;
		next = infile->GetToken();

		if (next->type != Open)
		{
			infile->ErrorMessage("'(' ܂", Error::error, next->locate);
		}

		Token *top = 0;
		Token *last = 0;

		class AutoDeleter
		{
			Token **top;

			public:
			AutoDeleter(Token **t) {top = t;}
			~AutoDeleter()
			{
				for(Token *p = *top; p;)
				{
					Token *r = p->next;

					delete p;
					p = r;
				}
			}
		} autodeleter(&top);

		next = infile->GetToken();
		while(true)
		{
			if (next->type == Close)
			{
				next = infile->GetToken();
				break;
			}
			else if (next->type == String || next->type == Number)
			{
				Token *t = new Token;
				*t = *next;
				t->next = 0;

				if (last)
				{
					last->next = t;
					last = t;
				}
				else
				{
					last = top = t;
				}

				next = infile->GetToken();

				if (next->type == Comma)
				{
					next = infile->GetToken();
				}
				else if (next->type == Close)
				{
					next = infile->GetToken();
					break;
				}
				else
				{
					infile->ErrorMessage(", or ) ܂B", Error::error, next->locate);
				}
			}
			else if (next->type == Comma)
			{
				// ȗp[^
				Token *t = new Token();
				t->type = Null;
				if (last)
				{
					last->next = t;
					last = t;
				}
				else
				{
					last = top = t;
				}

				next = infile->GetToken();
			}
			else
			{
				string s = "@G[ ";
				s += next->str;
				int p = next->locate;

				next = infile->GetToken();	// ǂݎ̂

				infile->ErrorMessage(s.c_str(), Error::error, p);
			}
		}

		// ̃Z~R
		if (next->type != Semicolon)
		{
			infile->ErrorMessage("̃Z~RL܂B", Error::error, next->locate);
		}
		next = infile->GetToken();

		// ֐ĂяoB
		int i;
		for(i = 0; sysfunctable[i].name; i++)
		{
			if (name[0] == '@' && !stricmp(sysfunctable[i].name, name.c_str()+1))
			{
				(this->*sysfunctable[i].func)(top);
				break;
			}
			else if (!stricmp(sysfunctable[i].name, name.c_str()))
			{
				(this->*sysfunctable[i].func)(top);
				break;
			}

			if (!swrddone)
				infile->ErrorMessage("\[Xt@C̐擪ɂ ֐ SherryWRD() Kvł", Error::fatal, next->locate);
		}

		if (!sysfunctable[i].name)
		{
			string s = "֐ '";
			s += name;
			s += "'܂";
			infile->ErrorMessage(s.c_str(), Error::error, erp);
		}
	}
	else
	{
		string s = "@G[ ";
		s += next->str;

		int p = next->locate;

		next = infile->GetToken();	// ǂݎ̂

		infile->ErrorMessage(s.c_str(), Error::error, p);
	}

	return true;
}

// p[^`FbN
const char *Compiler::GetStr(Token *token)
{
	if (!token)
	{
		infile->ErrorMessage("p[^܂B");
	}
	else if (token->type == String)
	{
		return token->str.c_str();
	}
	else
	{
		infile->ErrorMessage("p[^܂B", Error::error, token->locate);
	}

	return 0;
}

int Compiler::GetNum(Token *token, double def, double rl, double rh)
{
	if (!token)
	{
		infile->ErrorMessage("p[^܂B");
	}
	else if (token->type == Number)
	{
		double i = token->number;

		if ((rl >= 0 && i < rl) ||
		    (rh >= 0 && i > rh))
		{
			char b[256];
			if (rl < 0)
				sprintf(b, "lI[o[Ă܂ l = %f`", rl);
			else if (rh < 0)
				sprintf(b, "lI[o[Ă܂ l = `%f", rh);
			else
				sprintf(b, "lI[o[Ă܂ l = %f`%f", rl, rh);

			infile->ErrorMessage(b, Error::error, token->locate);
		}

		return i;
	}
	else if (token->type == Null && def >= 0)
	{
		return def;
	}
	else
	{
		infile->ErrorMessage("p[^܂B", Error::error, token->locate);
	}

	return 0;
}

void Compiler::CheckEnd(Token *token)
{
	if (token)
		infile->ErrorMessage("p[^܂B", Error::error, token->locate);
}

bool Compiler::IsDisplayPage(int page)
{
	for(int i = 0; i < MAX_DISPPAGE; i++)
	{
		if (page == displaypage[i])
			return true;
	}

	if (page == TEXT_VRAM)
		return true;

	return false;
}

void Compiler::Invalidate(const SRect &r)
{
	if (!irecte)
	{
		irecte = true;
		irect = r;
	}
	else
	{
		if (irect.x1 > r.x1)
			irect.x1 = r.x1;
		if (irect.y1 > r.y1)
			irect.y1 = r.y1;
		if (irect.x2 < r.x2)
			irect.x2 = r.x2;
		if (irect.y2 < r.y2)
			irect.y2 = r.y2;
	}
}

void Compiler::PaintVram()
{
	if (!irecte)
		return;
	irecte = false;

	bool f = false;
	for(int i = 0; i < MAX_DISPPAGE; i++)
	{
		if (displaypage[i] < 0)
			continue;

		if (!f)
		{
			output->Move(displaypage[i], TRANSFER_VRAM, 255, irect, SPoint(irect.x1, irect.y1));
			f = true;
		}
		else
			output->MoveTransparent(displaypage[i], TRANSFER_VRAM, 255, irect, SPoint(irect.x1, irect.y1));
	}

	if (tw.page == TEXT_VRAM)
	{
		output->MoveTransparent(TEXT_VRAM, TRANSFER_VRAM, 255, irect, SPoint(irect.x1, irect.y1));
	}

	output->StoreVRAM(TRANSFER_VRAM, SPoint(irect.x1, irect.y1), SPoint(irect.x1, irect.y1), SPoint(irect.x2-irect.x1+1, irect.y2-irect.y1+1));
}


