/*
==============================================================================

	AppName

==============================================================================
                                      Copyright(C)1998 Fummy (T.Ohtake)
                                      All rights reserved.
==============================================================================

NXꗗ


* End of class list
==============================================================================
$Header:

$Log: $
==============================================================================
*/

#include "secl.h"
#include <stdio.h>
#include <jctype.h>

void Compiler::_SherryWRD(Token *top)
{
	if (!swrddone)
	{
		DisplayMessage("Sherry WRD mode.");

		int ver = GetNum(top, 2, 2, 2); top = top->next;

		delta = timebase = 48;
		if (top)
		{
			offset = GetNum(top, 0, 0); top = top->next;
		}
		swrddone = true;

		CheckEnd(top);

		output->CompilerName(COMPILER_NAME);
		output->TimeBase(timebase);
		if (debug)
		{
			for(int i = 0; i < infile->GetSources(); i++)
			{
				output->SourceFilename(i, infile->GetSourceFilename(i));
			}
		}
		output->End();

		SBinaryOut::VScreenDescription v[4];
		v[0].number = TRANSFER_VRAM;
		v[0].size.x = 640;
		v[0].size.y = 480;
		v[0].transparent = 0;
		v[1].number = GTEXTPAT_VRAM;
		v[1].size.x = 640;
		v[1].size.y = 16;
		v[1].transparent = 0;
		v[2].number = 0;
		v[2].size.x = 640;
		v[2].size.y = 480;
		v[2].transparent = 0;
		v[3].number = SMOOTH_VRAM;
		v[3].size.x = 640;
		v[3].size.y = 16;
		v[3].transparent = 0;

		output->AllocateScreen(v, 4);

		output->AllocatePalette(WORK_PALETTE);
		output->AllocatePalette(0);

		// GRB
		const int defpal[] = {
			0x000000, 0x0000FF, 0x00FF00, 0x00FFFF,
			0xFF0000, 0xFF00FF, 0xFFFF00, 0xFFFFFF };

		SBinaryOut::Palette pals[8];
		for(int i = 0; i < 8; i++)
		{
			pals[i].number = i;
			pals[i].red = (defpal[i] >> 8) & 0xFF;
			pals[i].green = (defpal[i] >> 16) & 0xFF;
			pals[i].blue = (defpal[i] >> 0) & 0xFF;
		}

		output->SetPalette(0, pals, 8);
		output->StorePalette(0);
	}
	else
		infile->ErrorMessage("@SherryWRD͕g܂");
}

void Compiler::_AllocatePage(Token *top)
{
	SBinaryOut::VScreenDescription v;
	v.number = GetNum(top, 0, 0, MAX_PAGE); top = top->next;
	if (top)
	{
		v.size.x = GetNum(top, 640, 0, 65535); top = top->next;
		v.size.y = GetNum(top, 480, 0, 65535); top = top->next;

		if (top)
		{
			v.transparent = GetNum(top, 0, 0, 255); top = top->next;
		}
		else
			v.transparent = 0;
	}
	else
		v.size.x = 640, v.size.y = 480, v.transparent = 0;
;
	CheckEnd(top);

	output->AllocateScreen(&v, 1);
}

void Compiler::_FreePage(Token *top)
{
	do
	{
		output->FreeScreen(GetNum(top, -1, 0, MAX_PAGE)); top = top->next;
	} while(top);
}

void Compiler::_FreePalatte(Token *top)
{
	do
	{
		output->FreePalette(GetNum(top, -1, 0, MAX_PALETTE)); top = top->next;
	} while(top);
}

void Compiler::_AllocatePalette(Token *top)
{
	do
	{
		output->AllocatePalette(GetNum(top, -1, 0, MAX_PALETTE)); top = top->next;
	} while(top);
}

void Compiler::_LoadPicture(Token *top)
{
	int number = GetNum(top, -1, 0, MAX_PAGE); top = top->next;
	int pal = GetNum(top, -1, 0, MAX_PALETTE); top = top->next;
	string fname = GetStr(top); top = top->next;

	CheckEnd(top);

	fname = ConvertPicture(fname.c_str());
	if (fname.is_null())
		infile->ErrorMessage("ΉĂȂtH[}bgłB");
	output->AllocateScreenWithLoad(number, pal, fname.c_str());
}

void Compiler::_DrawPicture(Token *top)
{
	string fname = GetStr(top); top = top->next;
	int gx1 = GetNum(top, -1, 0, 65535); top = top->next;
	int gy1 = GetNum(top, -1, 0, 65535); top = top->next;
	int gx2 = GetNum(top, -1, 0, 65535); top = top->next;
	int gy2 = GetNum(top, -1, 0, 65535); top = top->next;
	int xx = GetNum(top, -1, 0, 65535); top = top->next;
	int yy = GetNum(top, -1, 0, 65535); top = top->next;

	int pal = DUMMY_PALETTE;
	if (top)
	{
		pal = GetNum(top, DUMMY_PALETTE, 0, MAX_PALETTE); top = top->next;
	}
	CheckEnd(top);

	fname = ConvertPicture(fname.c_str());

	output->AllocateScreenWithLoad(WORK_VRAM, pal, fname.c_str());
	output->Move(WORK_VRAM, activepage, mask, SRect(gx1, gy1, gx2, gy2), SPoint(xx, yy));
	output->FreeScreen(WORK_VRAM);

	if (IsDisplayPage(activepage))
		Invalidate(SRect(xx, yy, xx+gx2-gx1, yy+gy2-gy1));
}

void Compiler::_DrawPictureTransparent(Token *top)
{
	string fname = GetStr(top); top = top->next;
	int gx1 = GetNum(top, -1, 0, 65535); top = top->next;
	int gy1 = GetNum(top, -1, 0, 65535); top = top->next;
	int gx2 = GetNum(top, -1, 0, 65535); top = top->next;
	int gy2 = GetNum(top, -1, 0, 65535); top = top->next;
	int xx = GetNum(top, -1, 0, 65535); top = top->next;
	int yy = GetNum(top, -1, 0, 65535); top = top->next;
	int pal = DUMMY_PALETTE;
	if (top)
	{
		int pal = GetNum(top, DUMMY_PALETTE, 0, MAX_PALETTE); top = top->next;
	}

	CheckEnd(top);

	fname = ConvertPicture(fname.c_str());
	output->AllocateScreenWithLoad(WORK_VRAM, pal, fname.c_str());
	output->MoveTransparent(WORK_VRAM, activepage, mask, SRect(gx1, gy1, gx2, gy2), SPoint(xx, yy));
	output->FreeScreen(WORK_VRAM);
	if (IsDisplayPage(activepage))
		Invalidate(SRect(xx, yy, xx+gx2-gx1, yy+gy2-gy1));
}

void Compiler::_DisplayPage(Token *top)
{
	int i;
	for(i = 0; i < MAX_DISPPAGE; i++)
	{
		displaypage[i] = GetNum(top, -1, 0, MAX_PAGE); top = top->next;
		if (!top)
		{
			i++;
			break;
		}
	}
	for(; i < MAX_DISPPAGE; i++)
	{
		displaypage[i] = -1;
	}
	CheckEnd(top);

	Invalidate(SRect(0, 0, 639, 479));
}

void Compiler::_ActivePage(Token *top)
{
	activepage = GetNum(top, -1, 0, MAX_PAGE); top = top->next;
	CheckEnd(top);
}

void Compiler::_MaskPattern(Token *top)
{
	mask = GetNum(top, -1, 0, 255); top = top->next;
	CheckEnd(top);
}

void Compiler::_Line(Token *top)
{
	int x1 = GetNum(top, -1, 0, 65535); top = top->next;
	int y1 = GetNum(top, -1, 0, 65535); top = top->next;
	int x2 = GetNum(top, -1, 0, 65535); top = top->next;
	int y2 = GetNum(top, -1, 0, 65535); top = top->next;
	int color = GetNum(top, -1, 0, 255); top = top->next;
	CheckEnd(top);

	output->DrawLine(activepage, mask, SRect(x1, y1, x2, y2), color);
	if (IsDisplayPage(activepage))
		Invalidate(SRect(x1, y1, x2, y2));
}

void Compiler::_BoxFill(Token *top)
{
	int x1 = GetNum(top, -1, 0, 65535); top = top->next;
	int y1 = GetNum(top, -1, 0, 65535); top = top->next;
	int x2 = GetNum(top, -1, 0, 65535); top = top->next;
	int y2 = GetNum(top, -1, 0, 65535); top = top->next;
	int color = GetNum(top, -1, 0, 255); top = top->next;
	CheckEnd(top);

	output->DrawBoxFill(activepage, mask, SRect(x1, y1, x2, y2), color);
	if (IsDisplayPage(activepage))
		Invalidate(SRect(x1, y1, x2, y2));
}

void Compiler::_Box(Token *top)
{
	int x1 = GetNum(top, -1, 0, 65535); top = top->next;
	int y1 = GetNum(top, -1, 0, 65535); top = top->next;
	int x2 = GetNum(top, -1, 0, 65535); top = top->next;
	int y2 = GetNum(top, -1, 0, 65535); top = top->next;
	int color = GetNum(top, -1, 0, 255); top = top->next;
	CheckEnd(top);

	output->DrawLine(activepage, mask, SRect(x1, y1, x2, y1), color);
	output->DrawLine(activepage, mask, SRect(x2, y1, x2, y2), color);
	output->DrawLine(activepage, mask, SRect(x1, y1, x1, y2), color);
	output->DrawLine(activepage, mask, SRect(x1, y2, x2, y2), color);
	if (IsDisplayPage(activepage))
		Invalidate(SRect(x1, y1, x2, y2));
}

void Compiler::_Fade(Token *top)
{
	int from = GetNum(top, -1, 0, MAX_PALETTE); top = top->next;
	int to = GetNum(top, -1, 0, MAX_PALETTE); top = top->next;
	int tick = GetNum(top, -1, 0); top = top->next;
	int step;
	if (top)
	{
		step = GetNum(top, 0, 1); top = top->next;
	}
	else
		step = tick > 10 ? tick/10 : 1;
	CheckEnd(top);

	for(int i = 0; i <= tick+step-1; i += step)
	{
		int per;
		if (i < tick)
		{
			per = i*100/tick;
			output->SetTime(time + i);
		}
		else
		{
			per = 100;
			output->SetTime(time + tick);
		}
			output->MergePalette(from, to, WORK_PALETTE, 0, 8, 0, 0, 8, 0, 100-per, per);
		output->StorePalette(WORK_PALETTE);
	}
	output->SetTime(time);
}

void Compiler::_PaletteMix(Token *top)
{
	int to = GetNum(top, -1, 0, MAX_PALETTE); top = top->next;
	int from1 = GetNum(top, -1, 0, MAX_PALETTE); top = top->next;
	int from2 = GetNum(top, -1, 0, MAX_PALETTE); top = top->next;
	int per = GetNum(top, -1, 0, 100); top = top->next;
	CheckEnd(top);

	output->MergePalette(from1, from2, to, 0, 8, 0, 0, 8, 0, 100-per, per);
}

void Compiler::_PaletteContrast(Token *top)
{
	int from1 = GetNum(top, -1, 0, MAX_PALETTE); top = top->next;
	int to = GetNum(top, -1, 0, MAX_PALETTE); top = top->next;
	int per = GetNum(top, -1, 0, 100); top = top->next;
	CheckEnd(top);

	output->MergePalette(from1, to, 0, 0, 8, 0, 0, 8, 0, 100-per, per);
}

struct { int step; char mask[8*8]; } masktable[] =
 {
   { // SAS~ɃRs[
     4,
	 0x00, 0x00, 0x00, 0x18, 0x18, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x18, 0x24, 0x24, 0x18, 0x00, 0x00,
	 0x00, 0x3C, 0x66, 0x42, 0x42, 0x66, 0x3C, 0x00,
	 0xFF, 0xC3, 0x81, 0x81, 0x81, 0x81, 0xC3, 0xFF,
   },
   { // CPʂŁAォ牺
     8,
	 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF,
   },
   { // CPʂŁA
     8,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   },
   { // CPʂŁAE
     8,
	 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80,
	 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40,
	 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
	 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10,
	 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08,
	 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,
	 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
	 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,
   },
   { // CPʂŁAE獶
     8,
	 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,
	 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
	 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,
	 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08,
	 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10,
	 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
	 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40,
	 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80,
   },
   { // GIFC^[[X
     5,
	 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00, 0xFF, 0x00,
	 0x00, 0xFF, 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00, 0xFF,
   },
   { // tF[hC
     8,
	 0x88, 0x00, 0x00, 0x00, 0x88, 0x00, 0x00, 0x00,
	 0x22, 0x00, 0xAA, 0x00, 0x22, 0x00, 0xAA, 0x00,
	 0x00, 0x00, 0x00, 0x55, 0x00, 0x00, 0x00, 0x55,
	 0x00, 0x55, 0x00, 0x00, 0x00, 0x55, 0x00, 0x00,
	 0x55, 0x00, 0x00, 0x00, 0x55, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x55, 0x00, 0x00, 0x00, 0x55, 0x00,
	 0x00, 0xAA, 0x00, 0x00, 0x00, 0xAA, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0xAA, 0x00, 0x00, 0x00, 0xAA,
   },
   { //
     8,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   },
   { //
     8,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   },
  };

void Compiler::_MoveEffect(Token *top)
{
	int ef = GetNum(top, 0, 0, -1); top = top->next;
	int dtime = GetNum(top, 192, 0, -1); top = top->next;
	int interval = GetNum(top, 4, 1, -1); top = top->next;
	int x1 = GetNum(top, -1, 0, 65535); top = top->next;
	int y1 = GetNum(top, -1, 0, 65535); top = top->next;
	int x2 = GetNum(top, -1, 0, 65535); top = top->next;
	int y2 = GetNum(top, -1, 0, 65535); top = top->next;
	int xd = GetNum(top, -1, 0, 65535); top = top->next;
	int yd = GetNum(top, -1, 0, 65535); top = top->next;
	int vs = GetNum(top, -1, 0, MAX_PAGE); top = top->next;
	int vd = GetNum(top, -1, 0, MAX_PAGE); top = top->next;
	int trp = GetNum(top, 0, 0, 1); top = top->next;
	CheckEnd(top);

	SRect src(x1,y1,x2,y2);
	SPoint dst(xd, yd);

	int steps = dtime/interval;
	int wx = src.x2-src.x1;
	int wy = src.y2-src.y1;
	int wxh = wx/2;
	int wyh = wy/2;

	if (ef >= 0 && ef <= 6)
	{
		steps = masktable[ef].step;

		for(int i = 0; i < steps; i++)
		{
			output->SetTime(time+dtime*i/steps);
			output->MoveMask(vs, vd, mask, trp, src, dst, SPoint(8, 8), masktable[ef].mask+8*i);
			if (IsDisplayPage(vd))
			{
				Invalidate(SRect(xd, yd, xd+x2-x1, yd+y2-y1));
				PaintVram();
			}
		}
	}
	else if (ef >= 20 && ef <= 30) // Cv
	{
		for(int i = 0; i < steps; i++)
		{
			//
			SRect src2 = src;
			SPoint dst2 = dst;

			int xt = wx*i/(steps-1);
			int yt = wy*i/(steps-1);

			if (ef == 20)
			{
				src2.x2 = src.x1 + xt;
				src2.y2 = src.y1 + yt;
			}
			else if (ef == 21)
			{
				src2.x1 += wx - xt;
				dst2.x += wx - xt;
				src2.y2 = src.y1 + yt;
			}
			else if (ef == 22)
			{
				src2.x2 = src.x1 + xt;
				src2.y1 = src.y2 - yt;
				dst2.y = dst2.y + wy - yt;
			}
			else if (ef == 23)
			{
				src2.x1 = src.x2 - xt;
				dst2.x = dst2.x + wx - xt;
				src2.y1 = src.y2 - yt;
				dst2.y = dst2.y + wy - yt;
			}
			else if (ef == 24)
			{
				src2.x1 = src.x1 + (wx-xt)/2;
				dst2.x = dst.x + (wx-xt)/2;
				src2.x2 = src.x2 - (wx-xt)/2;
			}
			else if (ef == 25)
			{
				src2.y1 = src.y1 + (wy-yt)/2;
				dst2.y = dst.y + (wy-yt)/2;
				src2.y2 = src.y2 - (wy-yt)/2;
			}
			else if (ef == 26)
			{
				src2.x1 = src.x1 + (wx-xt)/2;
				dst2.x = dst.x + (wx-xt)/2;
				src2.x2 = src.x2 - (wx-xt)/2;
				src2.y1 = src.y1 + (wy-yt)/2;
				dst2.y = dst.y + (wy-yt)/2;
				src2.y2 = src.y2 - (wy-yt)/2;
			}
			else if (ef == 27)
			{
				src2.y2 -= wy-yt;
			}
			else if (ef == 28)
			{
				src2.y1 += wy-yt;
				dst2.y += wy-yt;
			}
			else if (ef == 29)
			{
				src2.x1 += wx-xt;
				dst2.x += wx-xt;
			}
			else if (ef == 30)
			{
				src2.x2 -= wx-xt;
			}

			output->SetTime(time+dtime*i/steps);
			output->Move(vs, vd, mask, src2, dst2);

			if (IsDisplayPage(vd))
			{
				Invalidate(SRect(dst2.x, dst2.y, dst2.x+src2.x2-src2.x1, dst2.y+src2.y2-src2.y1));
				PaintVram();
			}
		}
	}
	else if (ef >= 40 && ef <= 42)
	{
		int ms;
		if (ef == 40)
			ms = 8;
		if (ef == 41)
			ms = 16;
		if (ef == 42)
			ms = 32;

		int tx = (wx+ms)/ms;
		int ty = (wy+ms)/ms;

		steps = tx*ty;
		char *flag = new char[steps];
		memset(flag, 0, steps);

		for(int i = 0; i < steps; i++)
		{
			int x, y;

			int r;

			for(;;)
			{
				r = random(steps);
				if (!flag[r])
				{
					flag[r] = 1;
					break;
				}
			}

			y = r/tx;
			x = r%tx;

			x *= ms;
			y *= ms;

			SRect src2 = src;
			src2.x1 += x;
			src2.y1 += y;
			src2.x2 = src2.x1 + ms-1;
			if (src2.x2 > src.x2)
				src2.x2 = src.x2;
			src2.y2 = src2.y1 + ms-1;
			if (src2.y2 > src.y2)
				src2.y2 = src.y2;

			SPoint dst2 = dst;
			dst2.x += x;
			dst2.y += y;

			output->SetTime(time+dtime*i/steps);
			output->Move(vs, vd, mask, src2, dst2);

			if (IsDisplayPage(vd))
			{
				Invalidate(SRect(dst2.x, dst2.y, dst2.x+src2.x2-src2.x1, dst2.y+src2.y2-src2.y1));
				PaintVram();
			}
		}

		delete flag;
	}
	else if (ef >= 43 && ef <= 47)
	{
		for(int i = 0; i < steps; i++)
		{
			int xt = wx*i/(steps-1);
			int yt = wy*i/(steps-1);

			output->SetTime(time+dtime*i/steps);

			if (ef == 43)
			{
				// C 
				for(int y = 0; y <= wy ;y+=2)
				{
					SRect src2 = src;
					SPoint dst2 = dst;

					src2.y1 = src2.y2 = src.y1+y;
					dst2.y += y;

					src2.x1 += wx-xt;

					output->Move(vs, vd, mask, src2, dst2);
				}
				// C 
				for(int y = 1; y <= wy ;y+=2)
				{
					SRect src2 = src;
					SPoint dst2 = dst;

					src2.y1 = src2.y2 = src.y1+y;
					dst2.y += y;

					src2.x2 = src.x1+xt;
					dst2.x += wx-xt;

					output->Move(vs, vd, mask, src2, dst2);
				}
			}
			else if (ef == 46)
			{
				SRect src2 = src;
				SPoint dst2 = dst;

				src2.x1 += wx-xt;

				output->Move(vs, vd, mask, src2, dst2);
			}
			else if (ef == 47)
			{
				SRect src2 = src;
				SPoint dst2 = dst;

				src2.x2 = src.x1+xt;
				dst2.x += wx-xt;

				output->Move(vs, vd, mask, src2, dst2);
			}
			else if (ef == 44)
			{
				SRect src2 = src;
				SPoint dst2 = dst;

				src2.y1 += wy-yt;

				output->Move(vs, vd, mask, src2, dst2);
			}
			else if (ef == 45)
			{
				SRect src2 = src;
				SPoint dst2 = dst;

				src2.y2 = src.y1+yt;
				dst2.y += wx-yt;

				output->Move(vs, vd, mask, src2, dst2);
			}

			if (IsDisplayPage(vd))
			{
				Invalidate(SRect(xd, yd, xd+x2-x1, yd+y2-y1));
				PaintVram();
			}
		}
	}
	else
	{
		infile->ErrorMessage("ȓʔԍłB");
	}

	output->SetTime(time);
}

void Compiler::_MoveTransparent(Token *top)
{
	int x1 = GetNum(top, -1, 0, 65535); top = top->next;
	int y1 = GetNum(top, -1, 0, 65535); top = top->next;
	int x2 = GetNum(top, -1, 0, 65535); top = top->next;
	int y2 = GetNum(top, -1, 0, 65535); top = top->next;
	int xd = GetNum(top, -1, 0, 65535); top = top->next;
	int yd = GetNum(top, -1, 0, 65535); top = top->next;
	int vs = GetNum(top, -1, 0, MAX_PAGE); top = top->next;
	int vd = GetNum(top, -1, 0, MAX_PAGE); top = top->next;
	CheckEnd(top);

	output->MoveTransparent(vs, vd, mask, SRect(x1, y1, x2, y2), SPoint(xd, yd));

	if (IsDisplayPage(vd))
		Invalidate(SRect(xd, yd, xd+x2-x1, yd+y2-y1));
}

void Compiler::_Move(Token *top)
{
	int x1 = GetNum(top, -1, 0, 65535); top = top->next;
	int y1 = GetNum(top, -1, 0, 65535); top = top->next;
	int x2 = GetNum(top, -1, 0, 65535); top = top->next;
	int y2 = GetNum(top, -1, 0, 65535); top = top->next;
	int xd = GetNum(top, -1, 0, 65535); top = top->next;
	int yd = GetNum(top, -1, 0, 65535); top = top->next;
	int vs = GetNum(top, -1, 0, MAX_PAGE); top = top->next;
	int vd = GetNum(top, -1, 0, MAX_PAGE); top = top->next;
	CheckEnd(top);

	output->Move(vs, vd, mask, SRect(x1, y1, x2, y2), SPoint(xd, yd));

	if (IsDisplayPage(vd))
		Invalidate(SRect(xd, yd, xd+x2-x1, yd+y2-y1));
}

void Compiler::_ChangePalette(Token *top)
{
	int pal = GetNum(top, -1, 0, MAX_PALETTE); top = top->next;
	CheckEnd(top);

	output->StorePalette(pal);
}

void Compiler::_SetPaletteAll(Token *top)
{
	int pal = GetNum(top, -1, 0, MAX_PALETTE); top = top->next;
	int cl = GetNum(top, -1, 0, 0xFFFFFF); top = top->next;
	CheckEnd(top);

	SBinaryOut::Palette pals[256];
	int i;
	for(i = 0; i < 256; i++)
	{
		pals[i].number = i;
		pals[i].red = (cl >> 16) & 0xFF;
		pals[i].green = (cl >> 8) & 0xFF;
		pals[i].blue = (cl >> 0) & 0xFF;
	}

	output->SetPalette(pal, pals, 256);
}

void Compiler::_SetPalette(Token *top)
{
	int pal = GetNum(top, -1, 0, MAX_PALETTE); top = top->next;
	int index = GetNum(top, 0, 0, 255); top = top->next;

	SBinaryOut::Palette pals[256];
	int i;

	for(i = 0; top && i < 256; i++)
	{
		if (index+i > 255)
			infile->ErrorMessage("F܂");

		int cl = GetNum(top, -1, 0, 0xFFFFFF); top = top->next;

		pals[i].number = index+i;
		pals[i].red = (cl >> 16) & 0xFF;
		pals[i].green = (cl >> 8) & 0xFF;
		pals[i].blue = (cl >> 0) & 0xFF;
	}

	CheckEnd(top);

	output->SetPalette(pal, pals, i);
}

void Compiler::_Start(Token *top)
{
	CheckEnd(top);

	PaintVram();
	output->Start();
}

void Compiler::_SetTime(Token *top)
{
	int measure = GetNum(top, -1, 1)-1; top = top->next;
	if (measure < 0)
		infile->ErrorMessage("ߔԍs");

	int tick = 0;
	if (top)
	{
		tick = GetNum(top, 0, 0); top = top->next;
	}

	CheckEnd(top);

	time = GetTick(measure)*timebase/smftimebase+tick;
}

void Compiler::_SetDelta(Token *top)
{
	delta = GetNum(top, -1, 1); top = top->next;
	CheckEnd(top);
}

void Compiler::_Wait(Token *top)
{
	int step = GetNum(top, -1, 1); top = top->next;
	CheckEnd(top);

	time += step;
}

void Compiler::_TextWindow(Token *top)
{
	tw.left = GetNum(top, 0, 0, 79)*tw.width; top = top->next;
	tw.top = GetNum(top, 0, 0, 29)*tw.height; top = top->next;
	tw.right = GetNum(top, 79, tw.left/tw.width, 79)*tw.width+tw.width-1; top = top->next;
	tw.bottom = GetNum(top, 29, tw.top/tw.height, 29)*tw.height+tw.height-1; top = top->next;
	CheckEnd(top);
}

void Compiler::_TextLocate(Token *top)
{
	tw.x = GetNum(top, tw.x, 0, 79)*tw.width; top = top->next;
	tw.y = GetNum(top, tw.y, 0, 29)*tw.height; top = top->next;
	if (top)
	{
		tw.color = GetNum(top, tw.color, 0, 255); top = top->next;
	}

	if (top)
	{
		tw.bcolor = GetNum(top, tw.bcolor, 0, 255); top = top->next;
	}
	CheckEnd(top);
}

void Compiler::_TextColor(Token *top)
{
	tw.color = GetNum(top, tw.color, 0, 255); top = top->next;
	if (top)
	{
		tw.bcolor = GetNum(top, tw.bcolor, 0, 255); top = top->next;
	}
	CheckEnd(top);
}

void Compiler::_TextMask(Token *top)
{
	tw.mask = GetNum(top, -1, 0, 255); top = top->next;
	CheckEnd(top);
}

void Compiler::_TextPage(Token *top)
{
	int btp = tw.page;

	tw.page = GetNum(top, tw.page, 0, MAX_PAGE); top = top->next;
	CheckEnd(top);

	if (btp != tw.page && tw.page == TEXT_VRAM)
	{
		output->FreeScreen(TEXT_VRAM);
	}
}

void Compiler::_TextHome(Token *top)
{
	CheckEnd(top);

	tw.x = tw.left;
	tw.y = tw.top;
}

void Compiler::_TextMode(Token *top)
{
	ton = GetNum(top, -1, 0, 3); top = top->next;
	CheckEnd(top);
}

void Compiler::_TextClear(Token *top)
{
	int x1 = 0, y1 = 0, x2 = 79, y2 = 29;
	if (top)
	{
		int x1 = GetNum(top, 0, 0, 79); top = top->next;
		int y1 = GetNum(top, 0, 0, 29); top = top->next;
		int x2 = GetNum(top, 79, x1, 79); top = top->next;
		int y2 = GetNum(top, 29, y1, 29); top = top->next;
		CheckEnd(top);
	}
	output->DrawBoxFill(tw.page, tw.mask, SRect(x1*8, y1*16, x2*8+7, y2*16+15), tw.bcolor);
	if (IsDisplayPage(tw.page))
		Invalidate(SRect(x1*8, y1*16, x2*8+7, y2*16+15));
}

void Compiler::_TextPatternOFF(Token *top)
{
	CheckEnd(top);

	pat = -1;
}

void Compiler::_TextPattern(Token *top)
{
	pat = GetNum(top, -1, 0, MAX_PAGE); top = top->next;
	int x = GetNum(top, -1, 0, 65535); top = top->next;
	int y = GetNum(top, -1, 0, 65535); top = top->next;
	CheckEnd(top);

	for(int i = 0; i < 40; i++)
	{
		output->Move(pat, GTEXTPAT_VRAM, 255, SRect(x, y, x+15, y+15), SPoint(i*16, 0));
	}
}

void Compiler::_DrawText(Token *top)
{
	int x = GetNum(top, -1, 0, 65535); top = top->next;
	int y = GetNum(top, -1, 0, 65535); top = top->next;
	int tcolor = GetNum(top, -1, 0, 255); top = top->next;
	string text = GetStr(top); top = top->next;
	CheckEnd(top);

	DrawText(activepage, x, y, mask, tcolor, 0, text.c_str());
}

void Compiler::_DrawLyricsRainbow(Token *top)
{
	int tx = GetNum(top, -1, 0, 65535); top = top->next;
	int ty = GetNum(top, -1, 0, 65535); top = top->next;
	int tcolor = GetNum(top, -1, 0, 255); top = top->next;
	int tc2 = GetNum(top, tcolor, 0, 255); top = top->next;
	int step = GetNum(top, 12, 1, -1); top = top->next;
	string text = GetStr(top); top = top->next;
	CheckEnd(top);

	int tm = time;
	int j = 0;
	if (tcolor < tc2)
	{
		int k = tc2-tcolor+1;

		for(int i = tcolor; i <= tc2; i++, j++)
		{
			DrawLyrics(activepage, tm+step*j/k, tx, ty, mask, i, text.c_str());
		}
	}
	else
	{
		int k = tcolor-tc2+1;
		for(int i = tcolor; i >= tc2; i--, j++)
		{
			DrawLyrics(activepage, tm+step*j/k, tx, ty, mask, i, text.c_str());
		}
	}
}

void Compiler::_DrawLyrics(Token *top)
{
	int tx = GetNum(top, tx, 0, 65535); top = top->next;
	int ty = GetNum(top, ty, 0, 65535); top = top->next;
	int tcolor = GetNum(top, tcolor, 0, 255); top = top->next;
	string text = GetStr(top); top = top->next;
	CheckEnd(top);

	DrawLyrics(activepage, time, tx, ty, mask, tcolor, text.c_str());
}

void Compiler::_CopyPalette(Token *top)
{
	int dst = GetNum(top, -1, 0, MAX_PALETTE); top = top->next;
	int src = GetNum(top, -1, 0, MAX_PALETTE); top = top->next;
	CheckEnd(top);

	output->CopyPalette(src, dst);
}

void Compiler::_End(Token *top)
{
	CheckEnd(top);

	if (endtime)
		time = endtime*timebase/smftimebase-1;
	else
		infile->ErrorMessage("tIԂvZł܂BMIDIt@Cw肵ĉB", Error::warnning);
}

// ==================================================================
//
// ==================================================================

void Compiler::DrawText(int page, int x, int y, int mask, int color, int bcolor, const char *text)
{
	int w = strlen(text)*8;

	if (pat < 0)
	{
		output->DrawString(page, mask, 3, color, bcolor, SPoint(x, y), text);
	}
	else
	{
		output->Move(GTEXTPAT_VRAM, page, 255, SRect(0, 0, w-1, 15), SPoint(x, y));
		output->DrawString(page, 255, 2, 0, 0, SPoint(x, y), text);
	}

	Invalidate(SRect(x, y, x+w-1, y+16-1));
}

int Compiler::DrawLyrics(int page, int tm, int tx, int ty, int mk, int col, const char *text, bool sm)
{
	TextWindow t;
	t.page = page;
	t.mask = mk;
	t.color = col;
	t.bcolor = 0;
	t.x = tx;
	t.y = ty;

	int tt = time;

	output->SetTime(tm);
	time = tm;

	TextLyricsOut(text, t);

	output->SetTime(tt);

	return tm;
}

int GetStep(const char **q)
{
	const char *p = *q;

	int step = -1;
	int bstep = 0;

	while(true)
	{
		if (*p == '.' && bstep)
		{
			p++;
			bstep /= 2;
			step += bstep;
		}
		else if (*p == '^' && bstep)
		{
			p++;
			const char *r = p;
			while(*p >= '0' && *p <= '9')
				p++;
			bstep = atoi(r);
			if (!bstep)
				bstep = 1;
			bstep = 192 / bstep;
			step += bstep;
		}
		else if (*p == '|' || !*p)
		{
			break;
		}
		else if (*p < '0' || *p > '9')
			break;
		else if (!bstep)
		{
			const char *r = p;
			while(*p >= '0' && *p <= '9')
				p++;
			bstep = atoi(r);
			bstep = bstep ? 192 / bstep : 0;
			step = bstep;
		}
		else
			break;
	}

	*q = p;
	return step;
}

void Compiler::TextLyricsOut(const char *p, TextWindow &t)
{
	bool ff = false;
	do
	{
		while(t.x+t.width-1 < t.right && t.y+t.height-1 <= t.bottom)
		{
			int s = t.x;
			char b[90];
			char *q = b;

			bool kakko = false;

			bool df = false;
			for(; t.x+t.width-1 <= t.right && *p && !(p[0] == ';' && !p[1]); )
			{
				if (ton == 3)
				{
					if (!kakko && *p == '|')
					{
						kakko = true;
						p++;
						continue;
					}

					if (kakko && *p == '|')
					{
						kakko = false;
						p++;
						break;
					}

					if (*p == '_')
					{
						p++;
						df = true;
						break;
					}
				}
				else if (ton == 2)
				{
					if (*p == '|')
					{
						df = true;
						break;
					}
				}

				if (t.x +t.width*2-1 > t.right && iskanji(*p))
				{
					t.x += t.width;
					break;
				}

				if (iskanji(*p))
					*q++ = *p++, t.x+=t.width;
				*q++ = *p++, t.x+=t.width;

				if (ton == 3 && !kakko)
					break;
			}
			*q = 0;

			int step[8];
			int steps = 0;

			if (*p == '|' && ton == 2)
			{
				p++;
				while(steps < 8)
				{
					int st = GetStep(&p);

					if (st < 0)
						st = delta;

					step[steps] = st;
					steps++;

					if (*p == '|')
					{
						p++;
						break;
					}

					if (*p != ',')
					{
						while(*p && *p != '|')
							p++;
						if (*p == '|')
							p++;
						break;
					}

					p++;
				}
			}
			else if (ton == 3)
			{
				steps++;
				step[0] = delta;
			}
			else
			{
				steps++;
				step[0] = 0;
			}

			for(int i = 0; i < steps; i++)
			{
				if (b[0])
				{
					UseText();

					if (i == steps-1)
					{
						DrawText(t.page, s, t.y, t.mask, t.color, t.bcolor, b);
					}
					else
					{
						int wx = strlen(b)*t.width;
						DrawText(SMOOTH_VRAM, 0, 0, t.mask, t.color, t.bcolor, b);
						output->Move(SMOOTH_VRAM, t.page, t.mask, SRect(0, 0, (i+1)*wx/steps, t.height-1), SPoint(s, t.y));
						Invalidate(SRect(s, t.y, s+wx-1, t.y+t.height-1));
					}
				}

				if ((b[0] && ton == 3) || (b[0] && ton == 2) || df)
				{
					PaintVram();
					time += step[i];
					oldtime = time;
					output->SetTime(time);
				}
			}

			if ((p[0] == ';' && !p[1]) || !*p)
				break;
		}

		if (p[0] == ';' && !p[1])
		{
			p++;
			break;
		}

		t.x = t.left; t.y+=t.height;

		if (t.y > t.bottom && t.height != 65535)
		{
			t.y -= t.height;
			t.x = t.left;
			output->Move(t.page, t.page, t.mask, SRect(t.left, t.top+t.height, t.right, t.bottom), SPoint(t.left, t.top));
			output->DrawBoxFill(t.page, t.mask, SRect(t.left, t.bottom-t.height, t.right, t.bottom), 0);
			if (IsDisplayPage(tw.page))
				Invalidate(SRect(t.left, t.top, t.right, t.bottom));
		}
	} while(*p);
}

void Compiler::UseText(void)
{
	if (tw.page < 0)
	{
		tw.page = TEXT_VRAM;
		SBinaryOut::VScreenDescription v[1];
		v[0].number = TEXT_VRAM;
		v[0].size.x = 640;
		v[0].size.y = 480;
		v[0].transparent = 0;
		output->AllocateScreen(v, 1);
	}
}

