string Compiler::GetToken()
{
	PassSpace();
	char *bf = new char[256];
	string b;

	bool quot = false;
	if (*p == '\"' && p < end)
	{
		p++;
		quot = true;
	}

	int i;
	for(i = 0; i < 255 && (quot || (*p != ')' && *p != ',')) && p < end; i++)
	{
		bf[i] = *p;
		if (iskanji(*p))
		{
			i++;
			p++;
			bf[i] = *p;
		}
		else if (quot && *p == '\"')
		{
			p++;
			break;
		}
		p++;
	}

	bf[i] = 0;
	b = bf;

	delete[] bf;

	return b;
}

void Compiler::PassSpace(bool f)
{
	while(*p == ' ' || *p == '\t' || (f && (*p == '\r' || *p == '\n')) )
	{
		if (p >= end)
			break;

		if (*p == '\n')
		{
			lines++;
			linep = p+1;
		}

		p++;
	}
}

/*
int Compiler::Expression(Token *)
{
	Token *top = 0;

	while(true)
	{
		Token *tk = LexicalAnalyzer();

		if (tail)
		{
			tail->next = tk;
			tk->prev = tail;
		}
		tail = tk;

		if (!top)
			top = tail;

		if (IsOp(tk->type))
		{
			// Zq

			// ỎZqǂݏo
			Token *p;
			for(p = tail; p; p = p->prev)
			{
				if (IsOp(p->type))
					break;
			}

			if (!p)
			{
				// 擪̉Zq
			}
			else
			{
				// D揇ʔr
				if (p->priority > tk->priority)
				{

		}
	}
}

void Compiler::DeleteTokenTree()
{
}

bool Compiler::CheckChr(int c, bool f)
{
	PassSpace();
	if (p < end && *p == c)
	{
		p++;
		return true;
	}
	else
	{
		if (f)
		{
			char b[256];
			wsprintf(b, "f~^ '%c' ܂", c);
			ErrorMessage(b);
		}

		return false;
	}
}

bool Compiler::IsEqual(const char *com)
{
	int i;
	for(i = 0; com[i] && p[i] && p+i < end; i++)
	{
		if (toupper(com[i]) != toupper(p[i]))
			return FALSE;
	}

	if (com[i])
		return false;
	else
	{
		p += i;

		return true;
	}
}

int Compiler::GetNum(int def, int rl, int rh)
{
	PassSpace();
	char *q;

	int i = strtol(p, &q, 0);

	if (q && q != p)
	{
		p = q;
		if ((rl >= 0 && i < rl) ||
		    (rh >= 0 && i > rh))
		{
			char b[256];
			if (rl < 0)
				wsprintf(b, "lI[o[Ă܂ l = %d`", rl);
			else if (rh < 0)
				wsprintf(b, "lI[o[Ă܂ l = `%d", rh);
			else
				wsprintf(b, "lI[o[Ă܂ l = %d`%d", rl, rh);
			ErrorMessage(b);
		}

		return i;
	}
	else if (def >= 0)
	{
		return def;
	}
	else
	{
		ErrorMessage("p[^܂B");
	}
}

*/

void Compiler::Output()
{
	output->End();
}

int Compiler::GetTick(int meas)
{
	int t = 0;
	int msz = smftimebase*4;

	for(int i = 0, j = 0; i < meas;)
	{
		if (j < tms && tm[j].measure == i)
		{
			msz = tm[j].measuresize;
			j++;
		}
		if (j >= tms)
		{
			t += msz*(meas-i);
			break;
		}

		t += msz*(tm[j].measure-i);
		i = tm[j].measure;
	}

	return t;
}

void Compiler::Invalidate(const SRect &r)
{
	if (!irecte)
	{
		irecte = true;
		irect = r;
	}
	else
	{
		if (irect.x1 > r.x1)
			irect.x1 = r.x1;
		if (irect.y1 > r.y1)
			irect.y1 = r.y1;
		if (irect.x2 < r.x2)
			irect.x2 = r.x2;
		if (irect.y2 < r.y2)
			irect.y2 = r.y2;
	}
}

void Compiler::PaintVram()
{
	if (!irecte)
		return;
	irecte = false;

	bool f = false;
	for(int i = 0; i < MAX_DISPPAGE; i++)
	{
		if (displaypage[i] < 0)
			continue;

		if (!f)
		{
			output->Move(displaypage[i], TRANSFER_VRAM, 255, irect, SPoint(irect.x1, irect.y1));
			f = true;
		}
		else
			output->MoveTransparent(displaypage[i], TRANSFER_VRAM, 255, irect, SPoint(irect.x1, irect.y1));
	}

	if (tp == TEXT_VRAM)
	{
		output->MoveTransparent(TEXT_VRAM, TRANSFER_VRAM, 255, irect, SPoint(irect.x1, irect.y1));
	}

	output->StoreVRAM(TRANSFER_VRAM, SPoint(irect.x1, irect.y1), SPoint(irect.x1, irect.y1), SPoint(irect.x2-irect.x1+1, irect.y2-irect.y1+1));
}

/*
void Compiler::UseText(void)
{
	if (tp < 0)
	{
		tp = TEXT_VRAM;
		SBinaryOut::VScreenDescription v[1];
		v[0].number = TEXT_VRAM;
		v[0].size.x = 640;
		v[0].size.y = 480;
		v[0].transparent = 0;
		output->AllocateScreen(v, 1);
	}
}
*/

void Compiler::DrawText(int page, int x, int y, int mask, int color, int bcolor, const char *text)
{
	int w = strlen(text)*8;

	if (pat < 0)
	{
		output->DrawText(page, mask, 3, color, bcolor, SPoint(x, y), text);
	}
	else
	{
		output->Move(GTEXTPAT_VRAM, page, 255, SRect(0, 0, w-1, 15), SPoint(x, y));
		output->DrawText(page, 255, 2, 0, 0, SPoint(x, y), text);
	}

	Invalidate(SRect(x, y, x+w-1, y+16-1));
}

int Compiler::DrawLyrics(int page, int tm, int tx, int ty, int mk, int col, const char *text, bool sm)
{
	PaintVram();
	int x = tx;
	for(const char *p = text; *p; tm += delta)
	{
		string s;
		char t[3];
		if (*p == '|')
		{
			p++;
			for(; *p;)
			{
				if (*p == '|')
				{
					p++;
					break;
				}
				else if (iskanji(*p))
				{
					t[0] = *p++;
					t[1] = *p++;
					t[2] = 0;
				}
				else
				{
					t[0] = *p++;
					t[1] = 0;
				}
				s += t;
			}
		}
		else if (*p == '\\')
		{
			p++;
			t[0] = *p++;
			t[1] = 0;
			s += t;
		}
		else if (*p == '_')
		{
			p++;
		}
		else if (iskanji(*p))
		{
			t[0] = *p++;
			t[1] = *p++;
			t[2] = 0;
			s += t;
		}
		else
		{
			t[0] = *p++;
			t[1] = 0;
			s += t;
		}
		output->SetTime(tm);

		if (s.length())
		{
			int wx = s.length()*8;
			DrawText(page, x, ty, mk, col, 0, s.c_str());
			x += wx;
			PaintVram();
		}
	}

	output->SetTime(time);

	return tm;
}

struct { int step; char mask[8*8]; } masktable[] =
 {
   { // SAS~ɃRs[
     4,
	 0x00, 0x00, 0x00, 0x18, 0x18, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x18, 0x24, 0x24, 0x18, 0x00, 0x00,
	 0x00, 0x3C, 0x66, 0x42, 0x42, 0x66, 0x3C, 0x00,
	 0xFF, 0xC3, 0x81, 0x81, 0x81, 0x81, 0xC3, 0xFF,
   },
   { // CPʂŁAォ牺
     8,
	 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF,
   },
   { // CPʂŁA
     8,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   },
   { // CPʂŁAE
     8,
	 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80,
	 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40,
	 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
	 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10,
	 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08,
	 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,
	 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
	 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,
   },
   { // CPʂŁAE獶
     8,
	 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,
	 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
	 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,
	 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08,
	 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10,
	 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
	 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40,
	 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80,
   },
   { // GIFC^[[X
     5,
	 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00, 0xFF, 0x00,
	 0x00, 0xFF, 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00, 0xFF,
   },
   { // tF[hC
     8,
	 0x88, 0x00, 0x00, 0x00, 0x88, 0x00, 0x00, 0x00,
	 0x22, 0x00, 0xAA, 0x00, 0x22, 0x00, 0xAA, 0x00,
	 0x00, 0x00, 0x00, 0x55, 0x00, 0x00, 0x00, 0x55,
	 0x00, 0x55, 0x00, 0x00, 0x00, 0x55, 0x00, 0x00,
	 0x55, 0x00, 0x00, 0x00, 0x55, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x55, 0x00, 0x00, 0x00, 0x55, 0x00,
	 0x00, 0xAA, 0x00, 0x00, 0x00, 0xAA, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0xAA, 0x00, 0x00, 0x00, 0xAA,
   },
   { //
     8,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   },
   { //
     8,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   },
  };

void Compiler::MoveEffect()
{
	CheckChr('(');
	const char *pp = p;
	int ef = GetNum(0, 0, -1);
	CheckChr(',');
	int dtime = GetNum(192, 0, -1);
	CheckChr(',');
	int interval = GetNum(4, 1, -1);
	CheckChr(',');
	int x1 = GetNum(-1, 0, 65535);
	CheckChr(',');
	int y1 = GetNum(-1, 0, 65535);
	CheckChr(',');
	int x2 = GetNum(-1, 0, 65535);
	CheckChr(',');
	int y2 = GetNum(-1, 0, 65535);
	CheckChr(',');
	int xd = GetNum(-1, 0, 65535);
	CheckChr(',');
	int yd = GetNum(-1, 0, 65535);
	CheckChr(',');
	int vs = GetNum(-1, 0, MAX_PAGE);
	CheckChr(',');
	int vd = GetNum(-1, 0, MAX_PAGE);
	CheckChr(',');
	int trp = GetNum(0, 0, 1);
	CheckChr(')');

	SRect src(x1,y1,x2,y2);
	SPoint dst(xd, yd);

	int steps = dtime/interval;
	int wx = src.x2-src.x1;
	int wy = src.y2-src.y1;
	int wxh = wx/2;
	int wyh = wy/2;

	if (ef >= 0 && ef <= 6)
	{
		steps = masktable[ef].step;

		for(int i = 0; i < steps; i++)
		{
			output->SetTime(time+dtime*i/steps);
			output->MoveMask(vs, vd, mask, trp, src, dst, SPoint(8, 8), masktable[ef].mask+8*i);
			if (IsDisplayPage(vd))
			{
				Invalidate(SRect(xd, yd, xd+x2-x1, yd+y2-y1));
				PaintVram();
			}
		}
	}
	else if (ef >= 20 && ef <= 30) // Cv
	{
		for(int i = 0; i < steps; i++)
		{
			//
			SRect src2 = src;
			SPoint dst2 = dst;

			int xt = wx*i/(steps-1);
			int yt = wy*i/(steps-1);

			if (ef == 20)
			{
				src2.x2 = src.x1 + xt;
				src2.y2 = src.y1 + yt;
			}
			else if (ef == 21)
			{
				src2.x1 += wx - xt;
				dst2.x += wx - xt;
				src2.y2 = src.y1 + yt;
			}
			else if (ef == 22)
			{
				src2.x2 = src.x1 + xt;
				src2.y1 = src.y2 - yt;
				dst2.y = dst2.y + wy - yt;
			}
			else if (ef == 23)
			{
				src2.x1 = src.x2 - xt;
				dst2.x = dst2.x + wx - xt;
				src2.y1 = src.y2 - yt;
				dst2.y = dst2.y + wy - yt;
			}
			else if (ef == 24)
			{
				src2.x1 = src.x1 + (wx-xt)/2;
				dst2.x = dst.x + (wx-xt)/2;
				src2.x2 = src.x2 - (wx-xt)/2;
			}
			else if (ef == 25)
			{
				src2.y1 = src.y1 + (wy-yt)/2;
				dst2.y = dst.y + (wy-yt)/2;
				src2.y2 = src.y2 - (wy-yt)/2;
			}
			else if (ef == 26)
			{
				src2.x1 = src.x1 + (wx-xt)/2;
				dst2.x = dst.x + (wx-xt)/2;
				src2.x2 = src.x2 - (wx-xt)/2;
				src2.y1 = src.y1 + (wy-yt)/2;
				dst2.y = dst.y + (wy-yt)/2;
				src2.y2 = src.y2 - (wy-yt)/2;
			}
			else if (ef == 27)
			{
				src2.y2 -= wy-yt;
			}
			else if (ef == 28)
			{
				src2.y1 += wy-yt;
				dst2.y += wy-yt;
			}
			else if (ef == 29)
			{
				src2.x1 += wx-xt;
				dst2.x += wx-xt;
			}
			else if (ef == 30)
			{
				src2.x2 -= wx-xt;
			}

			output->SetTime(time+dtime*i/steps);
			output->Move(vs, vd, mask, src2, dst2);

			if (IsDisplayPage(vd))
			{
				Invalidate(SRect(dst2.x, dst2.y, dst2.x+src2.x2-src2.x1, dst2.y+src2.y2-src2.y1));
				PaintVram();
			}
		}
	}
	else if (ef >= 40 && ef <= 42)
	{
		int ms;
		if (ef == 40)
			ms = 8;
		if (ef == 41)
			ms = 16;
		if (ef == 42)
			ms = 32;

		int tx = (wx+ms)/ms;
		int ty = (wy+ms)/ms;

		steps = tx*ty;
		char *flag = new char[steps];
		memset(flag, 0, steps);

		for(int i = 0; i < steps; i++)
		{
			int x, y;

			int r;

			for(;;)
			{
				r = random(steps);
				if (!flag[r])
				{
					flag[r] = 1;
					break;
				}
			}

			y = r/tx;
			x = r%tx;

			x *= ms;
			y *= ms;

			SRect src2 = src;
			src2.x1 += x;
			src2.y1 += y;
			src2.x2 = src2.x1 + ms-1;
			if (src2.x2 > src.x2)
				src2.x2 = src.x2;
			src2.y2 = src2.y1 + ms-1;
			if (src2.y2 > src.y2)
				src2.y2 = src.y2;

			SPoint dst2 = dst;
			dst2.x += x;
			dst2.y += y;

			output->SetTime(time+dtime*i/steps);
			output->Move(vs, vd, mask, src2, dst2);

			if (IsDisplayPage(vd))
			{
				Invalidate(SRect(dst2.x, dst2.y, dst2.x+src2.x2-src2.x1, dst2.y+src2.y2-src2.y1));
				PaintVram();
			}
		}

		delete flag;
	}
	else if (ef >= 43 && ef <= 47)
	{
		for(int i = 0; i < steps; i++)
		{
			int xt = wx*i/(steps-1);
			int yt = wy*i/(steps-1);

			output->SetTime(time+dtime*i/steps);

			if (ef == 43)
			{
				// C 
				for(int y = 0; y <= wy ;y+=2)
				{
					SRect src2 = src;
					SPoint dst2 = dst;

					src2.y1 = src2.y2 = src.y1+y;
					dst2.y += y;

					src2.x1 += wx-xt;

					output->Move(vs, vd, mask, src2, dst2);
				}
				// C 
				for(int y = 1; y <= wy ;y+=2)
				{
					SRect src2 = src;
					SPoint dst2 = dst;

					src2.y1 = src2.y2 = src.y1+y;
					dst2.y += y;

					src2.x2 = src.x1+xt;
					dst2.x += wx-xt;

					output->Move(vs, vd, mask, src2, dst2);
				}
			}
			else if (ef == 46)
			{
				SRect src2 = src;
				SPoint dst2 = dst;

				src2.x1 += wx-xt;

				output->Move(vs, vd, mask, src2, dst2);
			}
			else if (ef == 47)
			{
				SRect src2 = src;
				SPoint dst2 = dst;

				src2.x2 = src.x1+xt;
				dst2.x += wx-xt;

				output->Move(vs, vd, mask, src2, dst2);
			}
			else if (ef == 44)
			{
				SRect src2 = src;
				SPoint dst2 = dst;

				src2.y1 += wy-yt;

				output->Move(vs, vd, mask, src2, dst2);
			}
			else if (ef == 45)
			{
				SRect src2 = src;
				SPoint dst2 = dst;

				src2.y2 = src.y1+yt;
				dst2.y += wx-yt;

				output->Move(vs, vd, mask, src2, dst2);
			}

			if (IsDisplayPage(vd))
			{
				Invalidate(SRect(xd, yd, xd+x2-x1, yd+y2-y1));
				PaintVram();
			}
		}
	}
	else
	{
		ErrorMessage("ȓʔԍłB", pp);
	}

	output->SetTime(time);
}

int Compiler::Execute()
{
	lines = 1;
	linep = p;
	return ExecuteSherry();
}

int Compiler::ExecuteSherry()
{
	mimpi = false;
	swrddone = false;

	nowait = true;
	textmode = *p == '!' ? true : false;
	if (p[0] == '/' && p[1] == '/')
		textmode = false;

	ton = 1;
	errs = 0;

	time = 0;
	oldtime = 0;
	delta = 0;

	ln = -1;

	ttx = 0, tty = 0, tp = -1, tc = 7, tmask = 255, tb = 0;
	twx1 = 0; twx2 = 79; twy1 = 0; twy2 = 29;

	printf("\n");

	while(true)
	{
/*		if (ln != lines)
		{
			ln = lines;
			printf("Compiling %d line\r", lines);
		}
*/
		try{
		if (p >= end || !*p)
			break;

		if (!textmode)
			PassSpace();

		if (p >= end || !*p)
			break;

		if (oldtime != time)
		{
			PaintVram();
			output->SetTime(time);
			oldtime = time;
		}

		bool semi = false;

		const char *order = p;

		// fobO
		if (debug && ln != lines)
		{
			output->Debug(0, lines);
			ln = lines;
		}

		if (IsEqual("@SherryWRD"))
		{
			if (!swrddone)
			{
				printf("\nSherry WRD mode.");

				CheckChr('(');
				int ver = GetNum(1, 1, 1);
				//CheckChr(',', false);
				delta = timebase = 48;//GetNum(48, 1, 960);
				if (CheckChr(',', false))
				{
					offset = GetNum(0, 0);
				}
				swrddone = true;
				CheckChr(')');

				printf(" TPQN=%d\n\n", timebase);

				output->CompilerName(COMPILER_NAME);
				output->TimeBase(timebase);
				if (debug)
				{
					output->SourceFilename(0, infile.c_str());
				}
				output->End();

				SBinaryOut::VScreenDescription v[3];
				v[0].number = TRANSFER_VRAM;
				v[0].size.x = 640;
				v[0].size.y = 480;
				v[0].transparent = 0;
				v[1].number = GTEXTPAT_VRAM;
				v[1].size.x = 640;
				v[1].size.y = 16;
				v[1].transparent = 0;
				v[2].number = 0;
				v[2].size.x = 640;
				v[2].size.y = 480;
				v[2].transparent = 0;

				output->AllocateScreen(v, 3);

				output->AllocatePalette(WORK_PALETTE);
				output->AllocatePalette(0);

				// GRB
				const int defpal[] = {
					0x000000, 0x0000FF, 0x00FF00, 0x00FFFF,
					0xFF0000, 0xFF00FF, 0xFFFF00, 0xFFFFFF };

				SBinaryOut::Palette pals[8];
				for(int i = 0; i < 8; i++)
				{
					pals[i].number = i;
					pals[i].red = (defpal[i] >> 8) & 0xFF;
					pals[i].green = (defpal[i] >> 16) & 0xFF;
					pals[i].blue = (defpal[i] >> 0) & 0xFF;
				}

				output->SetPalette(0, pals, 8);
				output->StorePalette(0);
			}
			else
				ErrorMessage("@SherryWRD,@STARTUP͕g܂", order);
		}
/*		else if (IsEqual("@StartUp"))
		{
			mimpi = true;

			if (!swrddone)
			{
				CheckChr('(');
				int ver = GetNum(1);
				CheckChr(')');

				output->CompilerName("Sherry Easy Compiler ver.1.1 (MIMPI mode)");
				output->TimeBase(48);
				output->End();

				SBinaryOut::VScreenDescription v;
				v.number = 0;
				v.size.x = GetNum(640, 1, 65535);
				v.size.y = GetNum(480, 1, 65535);
				v.transparent = 0;

				output->AllocateScreen(&v, 1);

				output->AllocatePalette(0);
			}
			else
				ErrorMessage("@SherryWRD,@STARTUP͕g܂", order);
		}
*/		else if (!swrddone)
		{
			ErrorMessage("t@C̐擪ɂ́A@SherryWRDKv", order, Error::fatal);
		}
		else if (IsEqual("@AllocatePage") || IsEqual("@AllocPage"))
		{
			SBinaryOut::VScreenDescription v;
			CheckChr('(');
			v.number = GetNum(0, 0, MAX_PAGE);
			if (CheckChr(',', false))
			{
				v.size.x = GetNum(640, 0, 65535);
				CheckChr();
				v.size.y = GetNum(480, 0, 65535);

				if (CheckChr(',', false))
					v.transparent = GetNum(0, 0, 255);
				else
					v.transparent = 0;
			}
			else
				v.size.x = 640, v.size.y = 480, v.transparent = 0;
;

			CheckChr(')');
			output->AllocateScreen(&v, 1);
		}
		else if (IsEqual("@FreePage"))
		{
			CheckChr('(');

			do
			{
				output->FreeScreen(GetNum(-1, 0, MAX_PAGE));
			} while(CheckChr(',', false));

			CheckChr(')');
		}
		else if (IsEqual("@FreePalette"))
		{
			CheckChr('(');

			do
			{
				output->FreePalette(GetNum(-1, 0, MAX_PALETTE));
			} while(CheckChr(',', false));

			CheckChr(')');
		}
		else if (IsEqual("@AllocatePalette") || IsEqual("@AllocPalette"))
		{
			CheckChr('(');

			do
			{
				output->AllocatePalette(GetNum(-1, 0, MAX_PAGE));
			} while(CheckChr(',', false));

			CheckChr(')');
		}
		else if (IsEqual("@LoadPicture"))
		{
			CheckChr('(');
			int number = GetNum(-1, 0, MAX_PAGE);
			CheckChr();
			int pal = GetNum(-1, 0, MAX_PALETTE);
			CheckChr();
			string fname = GetToken();
			CheckChr(')');
			fname = ConvertPicture(fname.c_str());
			if (fname.is_null())
				ErrorMessage("ΉĂȂtH[}bgłB");
			output->AllocateScreenWithLoad(number, pal, fname.c_str());
		}
		else if (IsEqual("@DrawPicture"))
		{
			CheckChr('(');
			string fname = GetToken();
			CheckChr();
			int gx1 = GetNum(-1, 0, 65535);
			CheckChr();
			int gy1 = GetNum(-1, 0, 65535);
			CheckChr();
			int gx2 = GetNum(-1, 0, 65535);
			CheckChr();
			int gy2 = GetNum(-1, 0, 65535);
			CheckChr();
			int xx = GetNum(-1, 0, 65535);
			CheckChr();
			int yy = GetNum(-1, 0, 65535);

			int pal = DUMMY_PALETTE;
			if (CheckChr(',', false))
			{
				pal = GetNum(DUMMY_PALETTE, 0, MAX_PALETTE);
			}
			CheckChr(')');

			fname = ConvertPicture(fname.c_str());

			#ifdef IMPBUG
			if (pal == DUMMY_PALETTE)
			{
				output->AllocatePalette(pal);
			}
			#endif
			output->AllocateScreenWithLoad(WORK_VRAM, pal, fname.c_str());
			output->Move(WORK_VRAM, activepage, mask, SRect(gx1, gy1, gx2, gy2), SPoint(xx, yy));
			output->FreeScreen(WORK_VRAM);
			#ifdef IMPBUG
			if (pal == DUMMY_PALETTE)
			{
				output->FreePalette(pal);
			}
			#endif

			if (IsDisplayPage(activepage))
				Invalidate(SRect(xx, yy, xx+gx2-gx1, yy+gy2-gy1));
		}
		else if (IsEqual("@DrawPictureTransparent"))
		{
			CheckChr('(');
			string fname = GetToken();
			CheckChr();
			int gx1 = GetNum(-1, 0, 65535);
			CheckChr();
			int gy1 = GetNum(-1, 0, 65535);
			CheckChr();
			int gx2 = GetNum(-1, 0, 65535);
			CheckChr();
			int gy2 = GetNum(-1, 0, 65535);
			CheckChr();
			int xx = GetNum(-1, 0, 65535);
			CheckChr();
			int yy = GetNum(-1, 0, 65535);
			int pal = DUMMY_PALETTE;
			if (CheckChr(',', false))
			{
				int pal = GetNum(DUMMY_PALETTE, 0, MAX_PALETTE);
			}
			#ifdef IMPBUG
			if (pal == DUMMY_PALETTE)
			{
				output->AllocatePalette(pal);
			}
			#endif
			fname = ConvertPicture(fname.c_str());
			CheckChr(')');
			output->AllocateScreenWithLoad(WORK_VRAM, pal, fname.c_str());
			output->MoveTransparent(WORK_VRAM, activepage, mask, SRect(gx1, gy1, gx2, gy2), SPoint(xx, yy));
			output->FreeScreen(WORK_VRAM);
			#ifdef IMPBUG
			if (pal == DUMMY_PALETTE)
			{
				output->FreePalette(pal);
			}
			#endif
			if (IsDisplayPage(activepage))
				Invalidate(SRect(xx, yy, xx+gx2-gx1, yy+gy2-gy1));
		}
		else if (IsEqual("@DisplayPage") || IsEqual("@DPAGE"))
		{
			CheckChr('(');
			int i;
			for(i = 0; i < MAX_DISPPAGE; i++)
			{
				displaypage[i] = GetNum(-1, 0, MAX_PAGE);
				if (!CheckChr(',', false))
				{
					i++;
					break;
				}
			}
			for(; i < MAX_DISPPAGE; i++)
			{
				displaypage[i] = -1;
			}
			CheckChr(')');
			Invalidate(SRect(0, 0, 639, 479));
		}
		else if (IsEqual("@ActivePage") || IsEqual("@APAGE"))
		{
			CheckChr('(');
			activepage = GetNum(-1, 0, MAX_PAGE);
			CheckChr(')');
		}
		else if (IsEqual("@MaskPattern") || IsEqual("@MASK"))
		{
			CheckChr('(');
			mask = GetNum(-1, 0, 255);
			CheckChr(')');
		}
		else if (IsEqual("@LINE"))
		{
			CheckChr('(');
			int x1 = GetNum(-1, 0, 65535);
			CheckChr(',');
			int y1 = GetNum(-1, 0, 65535);
			CheckChr(',');
			int x2 = GetNum(-1, 0, 65535);
			CheckChr(',');
			int y2 = GetNum(-1, 0, 65535);
			CheckChr(',');
			int color = GetNum(-1, 0, 255);
			CheckChr(')');
			output->DrawLine(activepage, mask, SRect(x1, y1, x2, y2), color);
			if (IsDisplayPage(activepage))
				Invalidate(SRect(x1, y1, x2, y2));
		}
		else if (IsEqual("@BOXFILL"))
		{
			CheckChr('(');
			int x1 = GetNum(-1, 0, 65535);
			CheckChr(',');
			int y1 = GetNum(-1, 0, 65535);
			CheckChr(',');
			int x2 = GetNum(-1, 0, 65535);
			CheckChr(',');
			int y2 = GetNum(-1, 0, 65535);
			CheckChr(',');
			int color = GetNum(-1, 0, 255);
			CheckChr(')');
			output->DrawBoxFill(activepage, mask, SRect(x1, y1, x2, y2), color);
			if (IsDisplayPage(activepage))
				Invalidate(SRect(x1, y1, x2, y2));
		}
		else if (IsEqual("@BOX"))
		{
			CheckChr('(');
			int x1 = GetNum(-1, 0, 65535);
			CheckChr(',');
			int y1 = GetNum(-1, 0, 65535);
			CheckChr(',');
			int x2 = GetNum(-1, 0, 65535);
			CheckChr(',');
			int y2 = GetNum(-1, 0, 65535);
			CheckChr(',');
			int color = GetNum(-1, 0, 255);
			CheckChr(')');
			output->DrawLine(activepage, mask, SRect(x1, y1, x2, y1), color);
			output->DrawLine(activepage, mask, SRect(x2, y1, x2, y2), color);
			output->DrawLine(activepage, mask, SRect(x1, y1, x1, y2), color);
			output->DrawLine(activepage, mask, SRect(x1, y2, x2, y2), color);
			if (IsDisplayPage(activepage))
				Invalidate(SRect(x1, y1, x2, y2));
		}
		else if (IsEqual("@FADE"))
		{
			CheckChr('(');
			int from = GetNum(-1, 0, MAX_PALETTE);
			CheckChr(',');
			int to = GetNum(-1, 0, MAX_PALETTE);
			CheckChr(',');
			int tick = GetNum(-1, 0);
			int step;
			if (CheckChr(',', false))
				step = GetNum(0, 1);
			else
				step = tick > 10 ? tick/10 : 1;
			CheckChr(')');
			for(int i = 0; i <= tick+step-1; i += step)
			{
				int per;
				if (i < tick)
				{
					per = i*100/tick;
					output->SetTime(time + i);
				}
				else
				{
					per = 100;
					output->SetTime(time + tick);
				}

				output->MergePalette(from, to, WORK_PALETTE, 0, 8, 0, 0, 8, 0, 100-per, per);
				output->StorePalette(WORK_PALETTE);
			}
			output->SetTime(time);
		}
		else if (IsEqual("@PALETTEMIX") || IsEqual("@PMIX"))
		{
			CheckChr('(');
			int to = GetNum(-1, 0, MAX_PALETTE);
			CheckChr(',');
			int from1 = GetNum(-1, 0, MAX_PALETTE);
			CheckChr(',');
			int from2 = GetNum(-1, 0, MAX_PALETTE);
			CheckChr(',');
			int per = GetNum(-1, 0, 100);
			CheckChr(')');

			output->MergePalette(from1, from2, to, 0, 8, 0, 0, 8, 0, 100-per, per);
		}
		else if (IsEqual("@PALETTECONTRAST"))
		{
			CheckChr('(');
			int from1 = GetNum(-1, 0, MAX_PALETTE);
			CheckChr(',');
			int to = GetNum(-1, 0, MAX_PALETTE);
			CheckChr(',');
			int per = GetNum(-1, 0, 100);
			CheckChr(')');

			output->MergePalette(from1, to, 0, 0, 8, 0, 0, 8, 0, 100-per, per);
		}
/*		else if (IsEqual("@PMOVE") || IsEqual("@MovePlane"))
		{
		}
*/
		else if (IsEqual("@MoveEffect"))
		{
			MoveEffect();
		}
		else if (IsEqual("@TMOVE") || IsEqual("@MOVETRANSPARENT"))
		{
			CheckChr('(');
			int x1 = GetNum(-1, 0, 65535);
			CheckChr(',');
			int y1 = GetNum(-1, 0, 65535);
			CheckChr(',');
			int x2 = GetNum(-1, 0, 65535);
			CheckChr(',');
			int y2 = GetNum(-1, 0, 65535);
			CheckChr(',');
			int xd = GetNum(-1, 0, 65535);
			CheckChr(',');
			int yd = GetNum(-1, 0, 65535);
			CheckChr(',');
			int vs = GetNum(-1, 0, MAX_PAGE);
			CheckChr(',');
			int vd = GetNum(-1, 0, MAX_PAGE);
			CheckChr(')');

			output->MoveTransparent(vs, vd, mask, SRect(x1, y1, x2, y2), SPoint(xd, yd));

			if (IsDisplayPage(vd))
				Invalidate(SRect(xd, yd, xd+x2-x1, yd+y2-y1));
		}
		else if (IsEqual("@MOVE"))
		{
			CheckChr('(');
			int x1 = GetNum(-1, 0, 65535);
			CheckChr(',');
			int y1 = GetNum(-1, 0, 65535);
			CheckChr(',');
			int x2 = GetNum(-1, 0, 65535);
			CheckChr(',');
			int y2 = GetNum(-1, 0, 65535);
			CheckChr(',');
			int xd = GetNum(-1, 0, 65535);
			CheckChr(',');
			int yd = GetNum(-1, 0, 65535);
			CheckChr(',');
			int vs = GetNum(-1, 0, MAX_PAGE);
			CheckChr(',');
			int vd = GetNum(-1, 0, MAX_PAGE);
			CheckChr(')');

			output->Move(vs, vd, mask, SRect(x1, y1, x2, y2), SPoint(xd, yd));

			if (IsDisplayPage(vd))
				Invalidate(SRect(xd, yd, xd+x2-x1, yd+y2-y1));
		}
		else if (IsEqual("@PALCHG") || IsEqual("@ChangePalette") )
		{
			CheckChr('(');
			int pal = GetNum(-1, 0, MAX_PALETTE);
			CheckChr(')');

			output->StorePalette(pal);
		}
		else if (IsEqual("@SetPaletteAll"))
		{
			CheckChr('(');
			int pal = GetNum(-1, 0, MAX_PALETTE);
			CheckChr(',');
			int cl = GetNum(-1, 0, 0xFFFFFF);

			SBinaryOut::Palette pals[256];
			int i;
			for(i = 0; i < 256; i++)
			{
				pals[i].number = i;
				pals[i].red = (cl >> 16) & 0xFF;
				pals[i].green = (cl >> 8) & 0xFF;
				pals[i].blue = (cl >> 0) & 0xFF;
			}

			output->SetPalette(pal, pals, 256);
			CheckChr(')');
		}
		else if (IsEqual("@PAL") || IsEqual("@SetPalette"))
		{
			CheckChr('(');
			int pal = GetNum(-1, 0, MAX_PALETTE);
			CheckChr(',');
			int index = GetNum(0, 0, 255);

			SBinaryOut::Palette pals[256];
			int i;

			for(i = 0; CheckChr(',', false) && i < 256; i++)
			{
				if (index+i > 255)
					ErrorMessage("F܂");

				int cl = GetNum(-1, 0, 0xFFFFFF);

				pals[i].number = index+i;
				pals[i].red = (cl >> 16) & 0xFF;
				pals[i].green = (cl >> 8) & 0xFF;
				pals[i].blue = (cl >> 0) & 0xFF;
			}

			output->SetPalette(pal, pals, i);
			CheckChr(')');
		}
		else if (IsEqual("@START"))
		{
			PaintVram();
			output->Start();
		}
		else if (IsEqual("@TIME") || IsEqual("@SETTIME"))
		{
			CheckChr('(');
			const char *e = p;

			int measure = GetNum(-1, 1)-1;
			if (measure < 0)
				ErrorMessage("ߔԍs", e);

			int tick = 0;
			if (CheckChr(',', false))
				tick = GetNum(0, 0);

			CheckChr(')');

			time = GetTick(measure)*timebase/smftimebase+tick;
		}
		else if (IsEqual("@DELTA") || IsEqual("@SETDELTA"))
		{
			CheckChr('(');
			delta = GetNum(-1, 1);
			CheckChr(')');
		}
		else if (IsEqual("@WAIT"))
		{
			CheckChr('(');
			int step = GetNum(-1, 1);
			CheckChr(')');

			time += step;
		}
		else if (IsEqual("@TextWindow"))
		{
			CheckChr('(');
			twx1 = GetNum(0, 0, 79);
			CheckChr(',',false);
			twy1 = GetNum(0, 0, 29);
			CheckChr(',',false);
			twx2 = GetNum(79, twx1, 79);
			CheckChr(',',false);
			twy2 = GetNum(29, twy1, 29);
			CheckChr(')');
		}
		else if (IsEqual("@Locate") || IsEqual("@TEXTLOCATE"))
		{
			CheckChr('(');
			ttx = GetNum(ttx, 0, 79);
			CheckChr(',');
			tty = GetNum(tty, 0, 29);
			if (CheckChr(',', false))
				tc = GetNum(tc, 0, 255);
			if (CheckChr(',', false))
				tb = GetNum(tb, 0, 255);
			CheckChr(')');
		}
		else if (IsEqual("@TextColor") || IsEqual("@COLOR"))
		{
			CheckChr('(');
			tc = GetNum(tc, 0, 255);
			if (CheckChr(',', false))
				tb = GetNum(tb, 0, 255);
			CheckChr(')');
		}
		else if (IsEqual("@TextMask"))
		{
			CheckChr('(');
			tmask = GetNum(-1, 0, 255);
			CheckChr(')');
		}
		else if (IsEqual("@TextPage"))
		{
			int btp = tp;

			CheckChr('(');
			tp = GetNum(tp, 0, MAX_PAGE);
			CheckChr(')');

			if (btp != tp && tp == TEXT_VRAM)
			{
				output->FreeScreen(TEXT_VRAM);
			}
		}
		else if (IsEqual("@TextMode") || IsEqual("@TMODE"))
		{
			CheckChr('(');
			ton = GetNum(-1, 0, 2);
			CheckChr(')');
		}
		else if (IsEqual("@TextClear") || IsEqual("@TCLS"))
		{
			CheckChr('(');
			int x1 = 0, y1 = 0, x2 = 79, y2 = 29;
			if (!CheckChr(')', false))
			{
				int x1 = GetNum(0, 0, 79);
				CheckChr(',', false);
				int y1 = GetNum(0, 0, 29);
				CheckChr(',', false);
				int x2 = GetNum(79, x1, 79);
				CheckChr(',', false);
				int y2 = GetNum(29, y1, 29);
				CheckChr(')');
			}
			output->DrawBoxFill(tp, tmask, SRect(x1*8, y1*16, x2*8+7, y2*16+15), tb);
			if (IsDisplayPage(tp))
				Invalidate(SRect(x1*8, y1*16, x2*8+7, y2*16+15));
		}
		else if (IsEqual("@TextPatternOFF"))
		{
			CheckChr('(');
			CheckChr(')');

			pat = -1;
		}
		else if (IsEqual("@TextPattern"))
		{
			CheckChr('(');
			pat = GetNum(tx, 0, MAX_PAGE);
			CheckChr(',');
			int x = GetNum(-1, 0, 65535);
			CheckChr(',');
			int y = GetNum(-1, 0, 65535);
			CheckChr(')');

			for(int i = 0; i < 40; i++)
			{
				output->Move(pat, GTEXTPAT_VRAM, 255, SRect(x, y, x+15, y+15), SPoint(i*16, 0));
			}
		}
		else if (IsEqual("@TEXT") || IsEqual("@DrawText"))
		{
			CheckChr('(');
			tx = GetNum(tx, 0, 65535);
			CheckChr(',');
			ty = GetNum(ty, 0, 65535);
			CheckChr(',');
			tcolor = GetNum(tcolor, 0, 255);
			CheckChr(',');
			string text = GetToken();
			CheckChr(')');

			DrawText(activepage, tx, ty, mask, tcolor, 0, text.c_str());
		}
		else if (IsEqual("@LYRICSRAINBOW") || IsEqual("@DrawLyricsRainbow"))
		{
			CheckChr('(');
			tx = GetNum(tx, 0, 65535);
			CheckChr(',');
			ty = GetNum(ty, 0, 65535);
			CheckChr(',');
			tcolor = GetNum(tcolor, 0, 255);
			CheckChr(',');
			int tc2 = GetNum(tcolor, 0, 255);
			CheckChr(',');
			int step = GetNum(12, 1, -1);
			CheckChr(',');
			string text = GetToken();
			CheckChr(')');

			int tm = time;
			int j = 0;
			if (tcolor < tc2)
			{
				int k = tc2-tcolor+1;

				for(int i = tcolor; i <= tc2; i++, j++)
				{
					DrawLyrics(activepage, tm+step*j/k, tx, ty, mask, i, text.c_str());
				}
			}
			else
			{
				int k = tcolor-tc2+1;

				for(int i = tcolor; i >= tc2; i--, j++)
				{
					DrawLyrics(activepage, tm+step*j/k, tx, ty, mask, i, text.c_str());
				}
			}
		}
		else if (IsEqual("@LYRICS") || IsEqual("@DrawLyrics"))
		{
			CheckChr('(');
			tx = GetNum(tx, 0, 65535);
			CheckChr(',');
			ty = GetNum(ty, 0, 65535);
			CheckChr(',');
			tcolor = GetNum(tcolor, 0, 255);
			CheckChr(',');
			string text = GetToken();
			CheckChr(')');

			DrawLyrics(activepage, time, tx, ty, mask, tcolor, text.c_str());
		}
/*		else if (IsEqual("@Smooth") || IsEqual("@DrawSmooth"))
		{
			CheckChr('(');
			tx = GetNum(tx, 0, 65535);
			CheckChr(',');
			ty = GetNum(ty, 0, 65535);
			CheckChr(',');
			tcolor = GetNum(tcolor, 0, 255);
			CheckChr(',');
			string text = GetToken();
			CheckChr(')');

			DrawLyrics(activepage, time, tx, ty, mask, tcolor, text.c_str(), true);
		}
*/
/*		else if (IsEqual("@MergePalette"))
		{
		}
*/		else if (IsEqual("@CopyPalette"))
		{
			CheckChr('(');
			int dst = GetNum(-1, 0, MAX_PALETTE);
			CheckChr(',');
			int src = GetNum(-1, 0, MAX_PALETTE);
			CheckChr(')');

			output->CopyPalette(src, dst);
		}
/*		else if (IsEqual("@BINARY"))
		{
		}
*/		else if (IsEqual("@END"))
		{
			if (endtime)
				time = endtime*timebase/smftimebase-1;
			else
				ErrorMessage("tIԂvZł܂BMIDIt@Cw肵ĉB", order, Error::warnning);
		}
		else if (IsEqual("//"))
		{
			while( !(*p == '\r' || *p == '\n') && *p)
				p++;
			semi = true;
		}
		else if (*p == ';')
		{
			semi = true;
			nowait = true;
			p++;
		}
		else if (*p == '!' && textmode && ton)
		{
			bool ff = false;
			while(true)
			{
				for(; *p && tty <= twy2; tty++)
				{
					char b[90];
					char *q = b;
					int s = ttx;

					while(ttx <= twx2)
					{
						bool kakko = false;

						bool df = false;
						for(; ttx <= twx2 && *p && *p != ';' && *p != '\r' && *p != '\n'; )
						{
							if (ton == 2 && !kakko && *p == '|')
							{
								kakko = true;
								p++;
								continue;
							}

							if (ton == 2 && kakko && *p == '|')
							{
								kakko = false;
								p++;
								break;
							}

							if (*p == '_' && ton == 2)
							{
								p++;
								df = true;
								break;
							}

							if (ttx == twx2 && iskanji(*p))
							{
								ttx++;
								break;
							}

							if (iskanji(*p))
								*q++ = *p++, ttx++;
							*q++ = *p++, ttx++;

							if (ton == 2 && !kakko)
								break;
						}
						*q = 0;

						if (b[0])
						{
							UseText();

							DrawText(tp, s*8, tty*16, tmask, tc, tb, b);
;
						}

						if ((b[0] && ton == 2) || df)
						{
							PaintVram();
							time += delta;
							oldtime = time;
							output->SetTime(time);
						}

						if (*p == ';' || *p == '\r' || *p == '\n' || !*p)
							break;
					}

					if (*p == ';' || *p == '\r' || *p == '\n' || !*p)
						break;

					ttx = twx1;
				}

				if (*p != ';')
				{
					ttx = twx1; tty++;
				}

				if (tty > twy2)
				{
					tty = twy2;
					ttx = twx1;
					output->Move(tp, tp, tmask, SRect(twx1*8, (twy1+1)*16, twx2*8+7, twy2*16+15), SPoint(twx1*8, twy1*16));
					output->DrawBoxFill(tp, tmask, SRect(twx1*8, twy2*16, twx2*8+7, twy2*16+15), 0);
					if (IsDisplayPage(tp))
						Invalidate(SRect(twx1*8, twy1*16, twx2*8+7, twy2*16+15));
				}

				if (*p == ';' || *p == '\r' || *p == '\n' || !*p)
				{
					break;
				}

			}

			textmode = false;
		}
		else if (*p == '\r')
		{
			p++;
			semi = true;
		}
		else if (*p == '\n')
		{
			lines++;
			p++;
			linep = p;
			textmode = *p == '!' ? true : false;
			if (p[0] == '/' && p[1] == '/')
				textmode = false;

			if (!nowait)
				time += delta;
		}
		else if (*p == '@')
		{
			p++;
		}
		else if (*p == 0x1a || !*p)
		{
			break;
		}
		else
		{
			semi = true;
			ErrorMessage("@G[Aߕs\ȕł", p);
		}

		if (!semi)
			nowait = false;
		}
		catch(Error *err)
		{
			if (err->errtype == Error::error)
				printf("\nError ");
			else if (err->errtype == Error::warnning)
				printf("\nWarnning ");
			else if (err->errtype == Error::fatal)
				printf("\nFatal error ");
			printf(": %s - %s", infile.c_str(), err->msg.c_str());

			if (err->errloc && err->line)
			{
				const char *p = err->line;
				printf("\n->");
				while(*p != '\n' && *p != '\r' && *p)
					putchar(*p++);
				printf("\n  ");
				for(int i = 0; i < err->errloc-err->line; i++)
					putchar(' ');
				putchar('^');
//				putchar('\n');
			}

			while( !(*p == '\r' || *p == '\n') && *p)
				p++;

			if (err->errtype == Error::error || err->errtype == Error::fatal)
				errs++;

			ErrType e = err->errtype;

			delete err;

			if (e == Error::fatal)
				break;
		}
	}
	PaintVram();
	output->End();

	return errs;
}

bool Compiler::IsDisplayPage(int page)
{
	for(int i = 0; i < MAX_DISPPAGE; i++)
	{
		if (page == displaypage[i])
			return true;
	}

	if (page == TEXT_VRAM)
		return true;

	return false;
}

