/*
==============================================================================

	AppName

==============================================================================
                                      Copyright(C)1998 Fummy (T.Ohtake)
                                      All rights reserved.
==============================================================================

NXꗗ


* End of class list
==============================================================================
$Header:

$Log: $
==============================================================================
*/

#include "secl.h"

// ==================================================================
//
// ==================================================================

Identify *IdentifyTable::SearchImp(const char *name)
{
	string a = name;

	for(Identify *p = table[a.hash() % IDT_HASH_SIZE]; p; p = p->next)
	{
		if (p->name == name)
			return p;
	}

}

IdentifyTable::IdentifyTable(IdentifyTable *p)
{
	for(int i = 0; i < IDT_HASH_SIZE; i++)
	{
		table[i] = 0;
	}

	parent = p;
}

IdentifyTable::~IdentifyTable()
{
	for(int i = 0; i < IDT_HASH_SIZE; i++)
	{
		for(Identify *p = table[i]; p;)
		{
			Identify *n = p->next;
			delete p;
			p = n;
		}
	}
}

Identify *IdentifyTable::Search(const char *name)
{
	Identify *p = SearchImp(name);

	if (parent && !p)
	{
		return parent->Search(name);
	}
	else
		return p;
}

bool IdentifyTable::Add(Identify *p)
{
	int i = p->name.hash() % IDT_HASH_SIZE;

	p->next = table[i];
	table[i] = p;
}

// ==================================================================
//
// ==================================================================
Variable::Variable(const char *name, VariableType t, int arrays, int init)
{
	array = new Variable[arrays];
	number = arrays;
	for(int i = 0; i < arrays; i++)
	{
		array[i].number = init;
		array[i].type = t;
	}
}

