
#include "wrdsub.h"

#include <string.h>
#include <stdio.h>

char *Sstring::Alloc(int len)
{
	delete[] buffer;
	buffer = new char[len+1];

	return buffer;
}

Sstring::Sstring(const char *str)
{
	buffer = new char[strlen(str)+1];
	strcpy(buffer, str);
}

Sstring::Sstring(const char *str, int len)
{
	buffer = new char[len+1];
	memcpy(buffer, str, len);
	buffer[len] = 0;
}

Sstring::Sstring(const Sstring &o)
{
	buffer = 0;
	if (o.buffer)
	{
		Alloc(strlen(o.buffer));
		strcpy(buffer, o.buffer);
	}
	else
		buffer = 0;
}

Sstring::Sstring()
{
	buffer = 0;
}

Sstring::~Sstring()
{
	delete[] buffer;
}

Sstring &Sstring::operator=(const Sstring &o)
{
	delete[] buffer;
	buffer = 0;

	if (o.buffer)
	{
		Alloc(strlen(o.buffer));
		strcpy(buffer, o.buffer);
	}
	else
		buffer = 0;

	return *this;
}

// ==================================================================
//
// ==================================================================
SError::SError()
{
	line = locate = 0;
}

SError::SError(const char *str, const char *param)
{
	line = locate = 0;
	sprintf(errtext.Alloc(512), str, param);
}

SError::SError(const char *str, const char *p1, const char *p2)
{
	line = locate = 0;
	sprintf(errtext.Alloc(512), str, p1, p2);
}

SError::SError(const char *str, int p1, int p2)
{
	line = locate = 0;
	sprintf(errtext.Alloc(512), str, p1, p2);
}

SError::SError(const char *str, int p1)
{
	sprintf(errtext.Alloc(512), str, p1);
}

SErrorRect::SErrorRect(int l, const SRect &r, const char *msg)
{
	locate = l;
	sprintf(errtext.Alloc(1024),
	        "%08X: Invalid rectangle (%d,%d)-(%d,%d) %s",
	        l,
	        r.x1, r.y1, r.x2, r.y2,
	        msg ? msg : ""
	       );
}

SErrorPoint::SErrorPoint(int l, const SPoint &r, const char *msg)
{
	locate = l;
	sprintf(errtext.Alloc(1024),
	        "%08X: Invalid point (%d,%d) %s",
	        l,
	        r.x, r.y,
	        msg ? msg : ""
	       );
}

SErrorPalette::SErrorPalette(int l, int palette, const char *msg)
{
	locate = l;
	sprintf(errtext.Alloc(1024),
	        "%08X: %s #%d.",
	        l,
	        msg ? msg : "",
	        palette
	       );
}

SErrorScreen::SErrorScreen(int l, int screen, const char *msg)
{
	locate = l;
	sprintf(errtext.Alloc(1024),
	        "%08X: %s #%d.",
	        l,
	        msg ? msg : "",
	        screen
	       );
}

SErrorInput::SErrorInput(int l, const char *err)
{
	locate = l;
	sprintf(errtext.Alloc(1024),
	         "%08X: %s",
	         l,
	         err
	        );
}

SErrorInternal::SErrorInternal(int l, const char *err)
{
	locate = l;
	sprintf(errtext.Alloc(1024),
	         "Internal: %s",
	         l,
	         err
	        );
}

SErrorTextInput::SErrorTextInput(int l, const char *err)
{
	line = l;
	errtext = err;
}
