
#ifndef __S_SUB_H_
#define __S_SUB_H_

// ==================================================================
//  {f[^
// ==================================================================

typedef unsigned char SByte;
typedef unsigned short int SWord;
typedef unsigned long int SDword;

// ==================================================================
//  IuWFNg
// ==================================================================

class Sstring
{
	char *buffer;

	public:
	Sstring(const char *str);
	Sstring(const char *str, int len);
	Sstring(const Sstring &);
	Sstring();
	~Sstring();

	operator const char *() {return buffer ? buffer : "";}
	char *Alloc(int len);
	Sstring &operator=(const Sstring &);
};

// ==================================================================
//  eP
// ==================================================================
struct SRect
{
	SWord x1;
	SWord y1;
	SWord x2;
	SWord y2;

	SRect(SWord a, SWord b, SWord c, SWord d)
		{ x1 = a; y1 = b; x2 = c; y2 = d; }
	SRect()
		{ x1 = y1 = x2 = y2 = 0; }

};

struct SPoint
{
	SWord x;
	SWord y;

	SPoint(SWord a, SWord b)
		{ x = a; y = b; }
	SPoint()
		{ x = y = 0; }
};

inline SPoint operator+(const SPoint &p1, const SPoint &p2)
{
	return SPoint(p1.x+p2.x, p1.y+p2.y);
}

// ==================================================================
//  OIuWFNg
// ==================================================================

class SError
{
	protected:
	Sstring errtext;
	int locate;
	int line;

	public:
	SError(const char *str) {errtext = str;}
	SError(const char *str, const char *param);
	SError(const char *str, const char *p1, const char *p2);
	SError(const char *str, int p1, int p2);
	SError(const char *str, int p1);
	SError();
	virtual ~SError() {}

	const char *GetMessage() {return errtext;}
	int GetLine() {return line;}
	int GetLocate() {return locate;}
	void Raise() {throw *this;}
};

class SErrorRect : public SError
{
	public:
	SErrorRect(int locate, const SRect &, const char *msg = 0);
};

class SErrorPoint : public SError
{
	public:
	SErrorPoint(int locate, const SPoint &, const char *msg = 0);
};

class SErrorPalette : public SError
{
	public:
	SErrorPalette(int locate, int, const char *msg = 0);
};

class SErrorScreen : public SError
{
	public:
	SErrorScreen(int locate, int, const char *msg = 0);
};

class SErrorInput : public SError
{
	public:
	SErrorInput(int locate, const char *err);
};

class SErrorInternal : public SError
{
	public:
	SErrorInternal(int locate, const char *err);
};

class SErrorTextInput : public SError
{
	public:
	SErrorTextInput(int l, const char *err);
};
#endif
